package com.fossgalaxy.game.orders;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.entity.Resource;
import com.fossgalaxy.games.tbs.order.MoveOrder;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.awt.*;

/**
 * Created by Lhfver on 16/05/2018.
 */
public class BuffMoveOrder extends MoveOrder {

    public static final String OLD_ATTACK_RANGE = ".old-attackRange";
    public static final String OLD_ATK_RANGED = ".old-atkRanged";
    public static final String ATTACK_RANGE = "attackRange";
    public static final String ATK_RANGED = "atkRanged";

    public BuffMoveOrder(CubeCoordinate move) {
        super(move);
    }

    @Override
    public void doOrder(Entity entity, GameState state) {
        super.doOrder(entity, state);
        CubeCoordinate coordinate = entity.getPos();
        Resource resource = state.getResourceAt(coordinate);
        if(resource == null || !resource.getType().getName().equals("TowerBuff")){
            removeBuff(entity);
        }else{
            applyBuff(entity);
        }
    }

    private void applyBuff(Entity entity){
        if(entity.getProperty(OLD_ATTACK_RANGE) != 0) return;

        int oldRange = entity.getProperty(ATTACK_RANGE);
        int oldDamage = entity.getProperty(ATK_RANGED);

        entity.setProperty(OLD_ATTACK_RANGE, oldRange);
        entity.setProperty(OLD_ATK_RANGED, oldDamage);

        entity.setProperty(ATTACK_RANGE, oldRange + 1);
        entity.setProperty(ATK_RANGED, oldDamage + 25);
    }

    private void removeBuff(Entity entity){
        if(entity.getProperty(OLD_ATTACK_RANGE) == 0) return;

        entity.setProperty(ATTACK_RANGE, entity.getProperty(OLD_ATTACK_RANGE));
        entity.setProperty(ATK_RANGED, entity.getProperty(OLD_ATK_RANGED));
    }
}
