package com.fossgalaxy.game.orders;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.io.AudioRegistry;
import com.fossgalaxy.games.tbs.order.AttackOrder;
import com.fossgalaxy.games.tbs.order.Order;

import java.util.Collection;

/**
 * Ranged attacks don't deal damage to the defender.
 * <p>
 * Created by webpigeon on 16/10/17.
 */
public class HealOrderRanged implements Order {

    private final int healAmount;

    public HealOrderRanged(int healAmount) {
        this.healAmount = healAmount;
    }

    public void doOrder(Entity entity, GameState state) {
        int maxRange = entity.getType().getProperty("healRange", 0);

        Collection<Entity> entities = state.getOwnedEntities(entity.getOwner());
        for(Entity target : entities){
         //
            if (entity.equals(target)) {
                return;
            }

            if(state.getDistance(entity.getPos(), target.getPos()) <= maxRange) {
                int maxHealth = target.getType().getProperty("health", 25);
                target.setHealth(Math.min(maxHealth, target.getHealth() + healAmount));
            }
        }
    }

}
